package com.hzya.frame.u8c.ax.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.sysnew.user.entity.SysUserEntity;
import com.hzya.frame.u8c.ax.dao.IAxDao;
import com.hzya.frame.u8c.ax.entity.ArchivesEntity;
import com.hzya.frame.u8c.ax.entity.Ass;
import com.hzya.frame.u8c.ax.entity.Voucher;
import com.hzya.frame.u8c.ax.entity.VoucherDetails;
import com.hzya.frame.u8c.ax.entity.VoucherRoot;
import com.hzya.frame.u8c.ax.service.IAxService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.http.HttpEntity;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import com.hzya.frame.basedao.service.impl.BaseService;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;

/**
 * (BdCorp)表服务实现类
 *
 * @author makejava
 * @since 2023-09-06 14:47:18
 */
@Service("axServiceImpl")
public class AxServiceImpl extends BaseService<ArchivesEntity, String> implements IAxService {
    private IAxDao axDao;
    @Autowired
	public void setAxDao(IAxDao dao) {
		this.axDao = dao;
		this.dao = dao;
	}
	private final String voucherUrl = "http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface";
	private final String publicKey = "ZJYAWb7lhAUTYqekPkU+uHJv1/ObJxb7dT7sD8HPRDGAgyhCe7eDIk+3zDUT+v578prj";
	private final String secretKey = "fviZnLBsQUAGF8w8FSOdJi7XlIm/XAZclMxRagDLfTyJFlvnIBF3w66Hrpfzs8cYj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=";
	private final String appId = "800016";
	private final String apiCode = "8000160014";
	private final Object lock = new Object();

	/**
	 * @Author lvleigang
	 * @Description  凭证新增
	 * @Date 3:42 下午 2024/4/24
	 * @param object
	 * @return com.hzya.frame.web.entity.JsonResultEntity
	 **/
	@Override
	public JsonResultEntity thirdInterfaceVoucherInsert(JSONObject object) {
		JSONObject jsonObject = object.getJSONObject("jsonStr");
		if(jsonObject == null ){
			return BaseResult.getFailureMessageEntity("数据为空，请先传递数据");
		}
		if(!checkStr(jsonObject.getString("usercode"))){
			return BaseResult.getFailureMessageEntity("usercode为空");
		}
		if(!checkStr(jsonObject.getString("password"))){
			return BaseResult.getFailureMessageEntity("password为空");
		}
		if(!checkStr(jsonObject.getString("trantype"))){
			return BaseResult.getFailureMessageEntity("trantype为空");
		}
		if(!checkStr(jsonObject.getString("system"))){
			return BaseResult.getFailureMessageEntity("system为空");
		}
		if(!checkStr(jsonObject.getString("data"))){
			return BaseResult.getFailureMessageEntity("data为空");
		}
		VoucherRoot entity = getData("data", jsonObject, VoucherRoot.class);
		if(entity == null || entity.getVoucher() == null || entity.getVoucher().size() == 0){
			return BaseResult.getFailureMessageEntity("data为空");
		}
		List<String> fzhs = Arrays.asList(new String[]{"1", "2", "6", "73", "D01" , "jobass" , "93" , "96", "22"});
		for (int i = 0; i < entity.getVoucher().size(); i++) {
			Voucher voucher = entity.getVoucher().get(i);
			if(voucher.getDetails() != null && voucher.getDetails().size() > 0){
				for (int a = 0; a < voucher.getDetails().size(); a++) {
					VoucherDetails voucherDetails = voucher.getDetails().get(a);
					if(voucherDetails.getAss() != null && voucherDetails.getAss().size() > 0){
						for (int b = 0; b < voucherDetails.getAss().size(); b++) {
							Ass ass = voucherDetails.getAss().get(b);
							if(ass.getChecktypecode() != null && !"".equals(ass.getChecktypecode())){
								//存在需要转换的
								if(fzhs.contains(ass.getChecktypecode())){
									ArchivesEntity archivesEntity = new ArchivesEntity();
									archivesEntity.setArchivesType(ass.getChecktypecode());
									archivesEntity.setLeftCode(ass.getCheckvaluecode());
									//List<ArchivesEntity> archivesEntities = axDao.queryArchivesData(archivesEntity);
									//if(archivesEntities != null && archivesEntities.size() > 0){
									//	ass.setCheckvaluecode(archivesEntities.get(0).getRightCode());
									//}
								}
							}
						}
					}
				}
			}
		}

		HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();
		// HttpClient
		CloseableHttpClient closeableHttpClient = httpClientBuilder.disableCookieManagement().build();
		HttpPost post = new HttpPost(voucherUrl);
		CloseableHttpResponse response = null;

		RequestConfig requestConfig =  RequestConfig.custom().setConnectTimeout(60000).build();
		post.setConfig(requestConfig);//设置请求参数【超时时间】
		post.setHeader("usercode", jsonObject.getString("usercode"));
		post.setHeader("password", jsonObject.getString("password"));
		post.setHeader("trantype", jsonObject.getString("trantype"));
		post.setHeader("system", jsonObject.getString("system"));
		post.setHeader("publicKey", publicKey);
		post.setHeader("secretKey", secretKey);
		post.setHeader("appId", appId);
		post.setHeader("apiCode", apiCode);
		StringBuilder body = new StringBuilder();
		String bodys = JSON.toJSONString(entity);
		try {
			if (bodys != null && !"".equals(bodys)) {
				ByteArrayEntity byteArrayEntity = new ByteArrayEntity(bodys.getBytes("UTF-8"));
				byteArrayEntity.setContentType("application/json");
				post.setEntity(byteArrayEntity);
			}
			response = closeableHttpClient.execute(post);
			HttpEntity httpEntity = response.getEntity();
			synchronized (lock) {
				body.append(EntityUtils.toString(httpEntity));
			}
			logger.info("返回结果：" + body);
			JsonResultEntity resultEntity = JSON.parseObject(body.toString(),JsonResultEntity.class);
			return resultEntity;

		} catch (Exception e) {
			logger.error("请求错误：" + e.getMessage());
			body.append(e.getMessage());
			return BaseResult.getFailureMessageEntity("转发失败",body);
		}finally {
			try {
				// 关闭响应对象
				if (response != null) {
					response.close();
				}
				// 关闭响应对象
				if (closeableHttpClient != null) {
					closeableHttpClient.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	/**
	 * @Author lvleigang
	 * @Description  档案新增
	 * @Date 3:42 下午 2024/4/24
	 * @param object
	 * @return com.hzya.frame.web.entity.JsonResultEntity
	 **/
	@Override
	public JsonResultEntity thirdInterfaceArchivesInsert(JSONObject object) {
		return null;
	}
	/**
	 * @Author lvleigang
	 * @Description  档案修改
	 * @Date 3:42 下午 2024/4/24
	 * @param object
	 * @return com.hzya.frame.web.entity.JsonResultEntity
	 **/
	@Override
	public JsonResultEntity thirdInterfaceArchivesUpdate(JSONObject object) {
		return null;
	}
	/**
	 * @Author lvleigang
	 * @Description  档案删除
	 * @Date 3:42 下午 2024/4/24
	 * @param object
	 * @return com.hzya.frame.web.entity.JsonResultEntity
	 **/
	@Override
	public JsonResultEntity thirdInterfaceArchivesDelete(JSONObject object) {
		return null;
	}
}
